{$A-,B-,D-,E-,F-,I-,L-,N+,O-,R-,S-,V-}
{$M 65520,51200,655360}
(* Ein Programm fr die Rohrleitungsnetzberechnung von
   Mischsystemen.

   Das Programm ist so gut, da man in drei Stunden sein komplettes
   Netz durchrechnen kann und dann eine 1,3 kriegt.


   COPYRIGHT (C):
                 Martin Vogel
                 Helmholtzstr. 15
                 5800 Hagen 1
                 # 02331/881449
   Version vom:
		 23.4.87
   Aenderungen:

             16.12: Das Variablenfeld wird abgespeichert.
             18.12: Kosmetik, und Klasse IV wird beruecksichtigt.
             20.12: Verschiedene Dateinamen, Druckdatei.
*)
uses crt;
const
        ZeilenZahl=200;

               nue=1.31e-6;
                 g=9.80665;

type zeile=record
             zufluss:         array[1..3] of integer;
             flaeche:         array[2..4] of real;

             zuflussanzahl:                           integer;

             einzellaenge,  gesamtlaenge,
             einzelew,      gesamtew,
             einzelqsh,     gesamtqsh,
             einzelqsg,     gesamtqsg,
             einzelqr,      gesamtqr,      maxqr,
             qvoll,         vvoll,         dn,
             qtrocken,      htrocken,      vtrocken,
             qgesamt,       hgesamt,       vgesamt,
             Gelaende_o,    Gelaende_u,
             Rohr_o,        Rohr_u,
             js,            kb:                         real;

           end;
     str40=string[40];
     str70=string[70];

var  tabelle:   array[1..zeilenzahl] of zeile;
     datei:     file of zeile;
     name:      str40;
     seqdat:    text;
     kn,maxkn:  integer;
     altlesen,
     ende,
     neu,
     nureinkb:  boolean;
     zeichen:   char;

     r15,slw,qnn,
     qsh,generalkb:            real;

     Psi,
     EWDichte,
     Phi,
     rn:        array[2..4] of real;

function jaAntwort(frage:str70):boolean;
var zeichen:char;
  begin
    write(frage,' (J/N) ? ');
    repeat
      Zeichen:=ReadKey;
      zeichen:=upCase(zeichen);
    until zeichen in ['J','N'];
    if zeichen = 'J' then
      begin
        jaAntwort:=true;
        writeln('Ja')
      end
    else
      begin
        JaAntwort:=false;
        writeln('Nein')
      end;
  end;

procedure inputi(frage:str40;var wert:integer);
  var zahl:str40;
      errpos:integer;
  begin
    while length(frage)<40 do frage:=frage+' ';
    repeat
      write(frage,' [',wert:8,'] :');readln(zahl);
      if length(zahl)>0 then
        val(zahl,wert,errpos)
      else
        errpos:=0;
    until errpos=0
  end;

procedure inputr(frage:str40;var wert:real);
  var zahl:str40;
      errpos:integer;
  begin
    while length(frage)<40 do frage:=frage+' ';
    repeat
      write(frage,' [',wert:8:2,'] :');readln(zahl);
      if length(zahl)>0 then
        val(zahl,wert,errpos)
      else
        errpos:=0;
    until errpos=0
  end;

procedure inputs(frage:str40;var antwort:str40);
  var eingabe:str40;
  begin
    while length(frage)<40 do frage:=frage+' ';
    write(frage,' [',antwort,'] :');
    readln(eingabe);
    if length(eingabe)>0 then antwort := eingabe;
  end;

procedure punktweg(var name:str40);
var n:integer;
begin
    n:=pos('.',name);
    if n>0 then
      begin
        name:=copy(name,1,n-1);
        writeln(^g,'Extension wurde entfernt. Dateiname ist ',name);
      end;
end;

procedure Datenschreiben;
var n:integer;

begin
  inputs('Dateiname zur Speicherung ',name);
  punktweg(name);

  assign(seqdat,name+'.SEQ');
  rewrite(seqdat);
  writeln(seqdat,maxkn,r15,slw,qnn,generalkb);
  for n:=2 to 4 do
    begin
      writeln(seqdat,psi[n],EWDichte[n],rn[n]);
    end;
  close(seqdat);

  assign(datei,name+'.DAT');
  rewrite(datei);
  for n:=1 to maxkn do write(datei,tabelle[n]);
  close(datei);
end;

procedure Datenlesen;
var n:integer;

begin
  assign(seqdat,name+'.SEQ');
  reset(seqdat);
  readln(seqdat,maxkn,r15,slw,qnn,generalkb);
  for n:=2 to 4 do
    begin
      readln(seqdat,psi[n],EWDichte[n],rn[n]);
    end;
  close(seqdat);

  assign(datei,name+'.DAT');
  reset(datei);
  for n:=1 to maxkn do read(datei,tabelle[n]);
  close(datei);
end;

procedure druckdatei;
var n:integer;

begin

assign(seqdat,name+'.TXT');
writeln(name,'.TXT wird angelegt.');
rewrite(seqdat);

writeln(seqdat,
'Kan. Laenge  l_ges.  Fl.2  Fl.3  Fl.4  Psi    EW   EWges  Zufluesse');
    for n:=1 to maxkn do
      with tabelle[n] do
        begin
          if zuflussanzahl<>1 then writeln(seqdat);
          writeln(seqdat,
                  n:3,
                  einzellaenge:8:1,    gesamtlaenge:8:1,
                  flaeche[2]:6:2,      flaeche[3]:6:2,
                  flaeche[4]:6:2,
                   (psi[2]*flaeche[2]
                   +psi[3]*flaeche[3]
                   +psi[4]*flaeche[4])
                  /(flaeche[2]+flaeche[3]+flaeche[4]):6:2,
                  einzelew:6:0,        gesamtew:7:0,
                  zufluss[1]:4,',',zufluss[2]:3,',',zufluss[3]:3)
        end;
writeln(seqdat,^L);
writeln(seqdat,
'  Qsh   Qsh.ges   Qsg   Qsg.ges   Qtr    Phi     Qr     Qr.ges   maxQr  Kan.');

    for n:=1 to maxkn do
      with tabelle[n] do
        begin
          if zuflussanzahl<>1 then writeln(seqdat);
          writeln(seqdat,
                  einzelqsh*1000.0:6:2,  gesamtqsh*1000.0:8:2,
                  einzelqsg*1000.0:8:2,  gesamtqsg*1000.0:8:2,
                  qtrocken*1000.0:8:2,
                   (phi[2]*flaeche[2]+phi[3]*flaeche[3]+phi[4]*flaeche[4])
                  /(flaeche[2]+flaeche[3]+flaeche[4]):7:3,
                  einzelqr*1000.0:8:2,
                  gesamtqr*1000.0:9:2,   maxqr*1000.0:9:2,
                  n:4)
        end;
writeln(seqdat,^L);
writeln(seqdat,
'Qgesamt  kb     Js    DN   Qvoll  vvoll  Qtr/Qv  htr  vtr  Kan.');

    for n:=1 to maxkn do
      with tabelle[n] do
        begin
          if zuflussanzahl<>1 then writeln(seqdat);
          writeln(seqdat,
                  qgesamt*1000.0:7:2,    kb*1000.0:5:1,
                  js*1000.0:7:1,         dn*1000.0:6:0,
                  qvoll*1000.0:7:0,      vvoll:7:2,
                  qtrocken/qvoll:8:3,    htrocken*1000.0:5:0,
                  vtrocken:6:2,          n:4);
        end;
writeln(seqdat,^L);
writeln(seqdat,
'Qg/Qv  hges  vges   Gel_o  Gel_u Grbt_o Grbt_u Sohl_o Sohl_u Kan.');

    for n:=1 to maxkn do
      with tabelle[n] do
        begin
          if zuflussanzahl<>1 then writeln(seqdat);
          writeln(seqdat,
          qgesamt/qvoll:5:3,
          hgesamt*1000.0:6:0,          vgesamt:7:2,
          Gelaende_o:7:2,              Gelaende_u:7:2,
          Gelaende_o-Rohr_o+dn:7:2,
          Gelaende_u-Rohr_u+dn:7:2,
          Rohr_o-dn:7:2,               Rohr_u-dn:7:2,
          n:4);
        end;
close(seqdat);
end;

procedure allgemeines;
var n:integer; gut:boolean;
begin
  psi[2]:=0.6;      psi[3]:=0.4;      psi[4]:=0.35;
  EWDichte[2]:=300; EWDichte[3]:=150; EWDichte[4]:=100;
  rn[2]:=0.5;       rn[3]:=1.0;       rn[4]:=1.0;

  r15:=110.0;       slw:=240.0;       qnn:=12;
  generalkb:=0.0015;

  writeln;
  name:='Siwawi';
  repeat
    inputs('Name der Arbeitsdatei',name);
    punktweg(name);
    assign(datei,name+'.DAT');
    (*$i-*)
    reset(datei);
    (*$i+*)
    altlesen:=(ioresult=0);
    if not altlesen then
       gut:=jaAntwort('Datei ist nicht vorhanden.  Neu anlegen')
    else
       close(datei);
 until altlesen or gut;

  if altlesen then datenlesen;
  writeln;
  writeln('Allgemeine Angaben fr das gesamte Gebiet:');
  writeln;
  inputr('Ergiebigkeit des 15-Minuten-Regens [l/s]',r15);
  inputr('Husl. Schmutzwasseranfall     [l/(E*d)]',slw);
  inputr('Heranzuziehende Stundenzahl qhh         ',qnn);
  writeln;
  qsh := slw/qnn/3600.0/1000.0;
  writeln('Es ergibt sich ein qsh-Wert von ',qsh*1e6:4:2,' l/(s*1000 E)');
  writeln;
  nureinkb := jaAntwort(
	      'Wird fr das ganze Gebiet nur ein kb-Wert angewendet');
  if nureinkb then
      writeln('Wie gro ist dieser kb-Wert?')
  else
      writeln('Welcher kb-Wert wird vermutlich',
	      ' am hufigsten verwendet werden?');
  generalkb:=generalkb*1000.0;
  inputr('Geben Sie den kb-Wert in mm an:',generalkb);
  generalkb:=generalkb/1000.0;

  clrscr;
  for n:=2 to 4 do
    begin
      Writeln('Allgemeine Werte zur Bebauungsklasse ',n,':');
      inputr('Abflubeiwert Psi       ',psi[n]);
      inputr('Siedlungsdichte EW/ha   ',EWDichte[n]);
      inputr('Regenhufigkeit n (r15) ',rn[n]);
      Phi[n] := 38.0/(15.0+9.0) * (exp(-0.25*ln(rn[n])) - 0.369);
      writeln('Daraus ergibt sich ein Zeitbeiwert Phi von ',phi[n]:5:3);
      writeln;
    end;
end;

procedure eingabe;
var n,m,j    :integer;
    hilf,ln10:real;
    gut      :boolean;
    zeichen  :char;


  {Wer die folgende Routine in eigenen Programmen verwendet
   ohne meine Zustimmung eingeholt zu haben, ist ein
   ehrloser Schuft.}

  procedure holevhteil(d,qteil,vv:real;var vt,h:real);
  var hu,ho,b,a,u,f,qt,delta,hilf:real;
      abbrecher:integer;
    begin
      abbrecher:=1000;
      hu:=0.0;ho:=2.0;
      h:=0.5*(ho+hu);
      repeat
        b:=2.0*sqrt(h*(2.0-h));
        if h=1.0 then a:=pi/2.0 else a:=arctan(0.5*b/(1.0-h));
        if a<0 then a:=pi+a;
        u:=2.0*a;
        if h>1.0 then
          begin
            hilf:=0.5*(h-1.0);
            u:=u+b*hilf*(hilf*hilf+0.05)/0.15
          end;
        f:=(a-sin(2.0*a)/2)*d*d*0.25;
        vt:=vv*(exp(0.625*ln(f/u/d/d*8.0)));
        qt:=f*vt;
        delta:=(qt/qteil)-1.0;
        if delta<0 then hu:=h else ho:=h;
        h:=0.5*(ho+hu);
        abbrecher:=pred(abbrecher);
      until (abs(delta)<1e-3) or (abbrecher=0);
      h:=0.5*h*d;
      if abbrecher=0 then
        begin
          writeln(^g);
	  writeln('Iteration abgebrochen. Keine Lsung gefunden!');
          writeln;
        end;
  end;
  (*
     Alles ganz einfach, nicht wahr? Die Herleitung dieser Sch... Formeln
     hat mich ein paar Tage gekostet. Hat sich aber gelohnt, glaube ich.
  *)


  procedure holeqvvoll(dn,js,kb:real;var qvoll,vvoll:real);
  (* ln10 und nue sind hier global *)
    var hilf: real;
    begin
      hilf:=sqrt(2*g*dn*js);
      vvoll:=-2.0*ln((2.51*nue/hilf+kb/3.71)/dn)/ln10*hilf;
      qvoll:=pi/4*dn*dn*vvoll;
    end;

  begin
    ln10:=ln(10.0);
    clrscr;
    kn:=maxkn+1;
    inputi('Kanalnummer, 0 fuer Ende',kn);
    ende:=(kn=0);
    if ende then exit;
    neu:=kn>maxkn;
    with tabelle[kn] do
      begin
      if neu then
        begin
          maxkn        :=kn;
          zuflussanzahl:=1;
          einzellaenge :=50;
          kb           :=generalkb;
          flaeche[2]   :=0;
          flaeche[3]   :=0;
          flaeche[4]   :=0;
          Gelaende_o   :=0.0;
          Gelaende_u   :=0.0;
        end;

        inputi('Anzahl Zufluesse (0..3)',zuflussanzahl);
        for m:=1 to zuflussanzahl do
          begin
            if neu then zufluss[m]:=kn-1-zuflussanzahl+m;
	    writeln(m,'. Zuflu:');
            inputi('Von Kanal',zufluss[m])
          end;
        for m:=zuflussanzahl+1 to 3 do zufluss[m]:=0;

	inputr('Kanallnge',einzellaenge);
        gesamtlaenge:=einzellaenge;

        if nureinkb then
          kb:=generalkb
        else
          begin
            kb:=kb*1000.0;
            inputr('kb-Wert',kb);
            kb:=kb/1000.0;
          end;

        repeat
	  inputr('Abfluklasse II:   Flche (ha)',flaeche[2]);
	  inputr('Abfluklasse III:  Flche (ha)',flaeche[3]);
	  inputr('Abfluklasse IV:   Flche (ha)',flaeche[4]);
	  if (flaeche[2]+flaeche[3]+flaeche[4])<=0 then
            begin
              writeln(^g^j,
	      'Das geht leider nicht. Ich mu gleich durch die Flchensumme');
	      writeln(
	      'dividieren. Sie mu daher grer als null sein!',^J);
           end;


        until (flaeche[2]+flaeche[3]+flaeche[4]) > 0;

        einzelew:=round(flaeche[2]*ewdichte[2]
                       +flaeche[3]*ewdichte[3]
                       +flaeche[4]*ewdichte[4]);
        inputr('Einwohnerzahl',einzelew);
        gesamtew:=einzelew;

        einzelqsh:=einzelew*qsh*1000.0;
	writeln('Husl. Schmutzw. Qsh = ',einzelqsh:8:2);
        einzelqsh:=einzelqsh/1000.0;
        gesamtqsh:=einzelqsh;

        einzelqsg:=0.0;
        inputr('Gewerbl. Schmutzw. Qsg',einzelqsg);
        einzelqsg:=einzelqsg/1000.0;
        gesamtqsg:=einzelqsg;

        einzelqr:=r15*(psi[2]*flaeche[2]
                      +psi[3]*flaeche[3]
                      +psi[4]*flaeche[4])/1000.0;
	writeln('Regenabflu       Qr = ',einzelqr*1000.0:8:2);
        gesamtqr:=einzelqr;

        if zuflussanzahl>0 then
          begin
            Gelaende_o:=tabelle[zufluss[1]].Gelaende_u;
            Rohr_o    :=tabelle[zufluss[1]].Rohr_u;
            for m:=1 to zuflussanzahl do
              begin
                if tabelle[zufluss[m]].Rohr_u < Rohr_o then
                  Rohr_o := tabelle[zufluss[m]].Rohr_u;
                gesamtlaenge:=gesamtlaenge+tabelle[zufluss[m]].gesamtlaenge;
                gesamtew    :=gesamtew    +tabelle[zufluss[m]].gesamtew;
                gesamtqsh   :=gesamtqsh   +tabelle[zufluss[m]].gesamtqsh;
                gesamtqsg   :=gesamtqsg   +tabelle[zufluss[m]].gesamtqsg;
                gesamtqr    :=gesamtqr    +tabelle[zufluss[m]].gesamtqr;
              end;
            writeln;
	    write  ('Gelndehhe oben     = ',Gelaende_o      :8:2,'     ');
	    writeln('Rohrhhe oben      = ',Rohr_o          :8:2);
	    write  ('Bisher Gesamtlnge   = ',gesamtlaenge    :8:2,'     ');
	    writeln('Bisher Gesamteinw. = ',gesamtew        :5:0);
	    write  ('Bisher Gesamt Qsh    = ',gesamtqsh*1000.0:8:2,'     ');
	    writeln('Bisher Gesamt Qsg  = ',gesamtqsg*1000.0:8:2);
	    write  ('Bisher Gesamt Qr     = ',gesamtqr *1000.0:8:2,'     ');
          end
        else (* Wenn kein Zufluss: *)
          begin
            writeln;
            writeln;
	    inputr('Gelndehhe oben',Gelaende_o);

            (* Mindestverlegetiefe hier 2.20 m: *)
            Rohr_o := Gelaende_o - 2.20;
	    inputr('Rohrhhe    oben',Rohr_o);
          end;

        qtrocken:=gesamtqsh+gesamtqsg;
        maxqr:=gesamtqr*(phi[2]*flaeche[2]
                        +phi[3]*flaeche[3]
                        +phi[4]*flaeche[4])
                       /(flaeche[2]+flaeche[3]+flaeche[4]);
        qgesamt:=qtrocken+maxqr;

	writeln('Bisher max Qr      = ',maxqr*1000.0   :8:2);
        write  ('Bisher Trockenw.abfl.= ',qtrocken*1000.0:8:2,'     ');
	writeln('Bisher Gesamt Q    = ',qgesamt*1000.0 :8:2);
        writeln;
	inputr('Gelndehhe unten',Gelaende_u);
        clrscr;
	writeln('*-------- Iteration von Nennweite und Geflle --------*');
        writeln;
        Rohr_u := Gelaende_u - 2.20;
        dn:=0.3;
        for n:= 1 to ZuflussAnzahl do
          begin
            if tabelle[zufluss[n]].dn>dn then
               dn := tabelle[zufluss[n]].dn;
            hilf := Gelaende_u-2.50+dn;
            if Rohr_u < hilf then Rohr_u := hilf;
          end;
        js:=(Rohr_o-Rohr_u)/einzellaenge;
        if js<0.00005 then js:=0.00005;
	writeln('Das kleinstmgliche Geflle bei DN',dn*1000.0:5:0,' ist ',
                js*1000.0:6:2,'%.');
        repeat
          repeat
            js:=js*1000.0;
            repeat
	      inputr('Geflle [%.] ',js);
              if js <0.05 then writeln(^g,'Nicht unter 0.05 %. !');
            until js >= 0.05;
            js:=js/1000.0;

            dn:=0.25;

            repeat
              case round(dn*1000.0) of
                150..450: dn:=dn+0.05;
                500..900: dn:=dn+0.1;
                else      dn:=dn+0.2
              end;
              holeqvvoll(dn,js,kb,qvoll,vvoll);
            until (qvoll>=qgesamt) or (dn>=2.0);

            writeln;
	    writeln('Die kleinstmgliche Nennweite bei diesem Geflle ist ',
                    'DN',dn*1000.0:5:0,'.');
	    writeln('Das topografisch kleinstmgliche Geflle ist dabei ',
                    (Rohr_o-Gelaende_u+2.5-dn)/EinzelLaenge*1000.0:5:2,'%.');
            writeln;
            dn:=dn*1000.0;
            inputr('(0 fuer neues Gefaelle)   Nennweite DN ',dn);
            dn:=dn/1000.0;
          until dn>0;

          holeqvvoll(dn,js,kb,qvoll,vvoll);
          writeln;
          writeln('vvoll = ',vvoll:6:3,   ', Qvoll = ',qvoll*1000.0:8:2);
          holevhteil(dn,qtrocken,vvoll,vtrocken,htrocken);
          writeln('vtr   = ',vtrocken:6:3,', Qtr   = ',qtrocken*1000.0:8:2);
          writeln;
	  gut := not jaAntwort('Neues Geflle-Nennweiten-Paar');
        until gut;

        Rohr_u:=Rohr_o-EinzelLaenge*js;
        holevhteil(dn,qgesamt,vvoll,vgesamt,hgesamt);

        clrscr;
        writeln('*------ Ermittelte Kennwerte von Kanal ',
                kn,': ------*');
        writeln;
        writeln('Nennweite DN  ',dn*1000.0       :5:0);
        writeln;
	writeln('Geflle       ',js*1000.0       :8:2,' %.');
	writeln('Rohrhhe (u)  ',Rohr_u          :8:2,' m . NN');
	writeln('berdeckung   ',Gelaende_u
                                 -Rohr_u         :8:2,' m');
        writeln('Grabentiefe   ',Gelaende_u
                                 -Rohr_u+dn      :8:2,' m');
        writeln;
        writeln('Q voll        ',qvoll*1000.0    :8:2,' l/s');
        writeln('Q trocken     ',qtrocken*1000.0 :8:2,' l/s');
        writeln('Qtr/Qv        ',qtrocken/qvoll  :9:3);
        writeln('Q gesamt      ',qgesamt*1000.0  :8:2,' l/s');
        writeln('Qges/Qv       ',qgesamt/qvoll   :9:3);
        writeln;
        writeln('h trocken     ',htrocken*1000.0 :5:0,' mm');
        writeln('h gesamt      ',hgesamt*1000.0  :5:0,' mm');
        writeln;
        writeln('v voll        ',vvoll           :8:2,' m/s');
        writeln('v trocken     ',vtrocken        :8:2,' m/s');
        writeln('v gesamt      ',vgesamt         :8:2,' m/s');

	writeln(^j^j,'Eine Taste drcken');Zeichen:=ReadKey;
      end
  end;

(*********************************************************************)
(***                                                               ***)
(***                  Hauptprogramm  SIWAWI.PAS                    ***)
(***                                                               ***)
(*********************************************************************)


begin
  clrscr;
  writeln('         Hydraulische Berechnung einer Mischsystementwsserung.');
  writeln('         ======================================================');
  writeln;
  writeln('               Copyright (C) 1987, 1989 by  Martin Vogel.');
  writeln;
  writeln('                          Maximal ',zeilenzahl,' Kanle!'^j^j);
  writeln('    Zahlenwerte in eckigen Klammern knnen mit ENTER besttigt werden');
  writeln('                und mssen nicht neu eingegeben werden.');
  writeln;

  ende :=false;
  kn   :=0;
  maxkn:=0;

  allgemeines;

  if altlesen then Datenlesen;

  repeat
    eingabe
  until ende;

  Datenschreiben;

  if jaAntwort('Soll eine Textdatei zum Druck angelegt werden')
     then Druckdatei;

  clrscr;
  Writeln('  Dieses Programm wurde mit der grten Sorgfalt erstellt.');
  writeln('Meine Ausarbeitung, die ich 1987 damit berechnet habe, wurde');
  writeln('auch mit Erfolg testiert. Dennoch bernehme ich keine Garantie');
  writeln('dafr, da die mit dem Programm ermittelten Werte immer richtig');
  writeln('sind. Insbesondere in Grenzsituationen sollte eine kontrollierende');
  writeln('Handrechnung immer gemacht werden.');
  writeln;
  writeln('  Der Quelltext zum Programm kann gerne eingesehen werden. Wer');
  writeln('ein klein wenig programmieren kann (Kenntnisse in BASIC, FORTRAN');
  writeln('oder Kisuaheli sind nicht notwendig), kann das Programm bestimmt');
  writeln('auch fr eine Trennsystemberechnung umschreiben.');
  writeln;
  writeln('                                      Martin Vogel im April 1989.');
end.
